/*
 *   ORXONOX - the hottest 3D action shooter ever to exist
 *                    > www.orxonox.net <
 *
 *
 *   License notice:
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License
 *   as published by the Free Software Foundation; either version 2
 *   of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 *   Author:
 *      Florian Zinggeler
 *   Co-authors:
 *      ...
 *
 */

/**
    @file DodgeRace.h
    @brief Gametype.
    @ingroup DodgeRace
*/

#ifndef _Pacman_H__
#define _Pacman_H__

#include "PacmanGelb.h"

#include "core/EventIncludes.h"
#include "core/command/Executor.h"
#include "core/config/ConfigValueIncludes.h"

#include "gamestates/GSLevel.h"
#include "chat/ChatManager.h"
#include <vector>

// ! HACK
#include "infos/PlayerInfo.h"

#include "core/command/ConsoleCommand.h"

#include "gametypes/Deathmatch.h"
#include "tools/Timer.h"

namespace orxonox
{

    class _PacmanExport Pacman : public Deathmatch
    {
       public:
            Pacman(Context* context);

            virtual void start() override;
            virtual void end() override;

            virtual void tick(float dt) override;

            virtual void playerPreSpawn(PlayerInfo* player) override;

            void levelUp();
            bool collis(Vector3 one, Vector3 other);
            void catched();
            void posreset();
            void takePoint(PacmanPointSphere* taken);
            PacmanGelb* getPlayer();
            int getPoints();


            bool bEndGame;
            bool bShowLevel;
            int lives;
            int multiplier;
            float counter;
            int pattern;
            float currentPosition;
            float lastPosition;

       private:
            PacmanGelb* player;
            PacmanGhost[] 
            Vector3 currentPosition;
            bool bcolli = false;


            Timer endGameTimer;
            int level;
            int point;
            bool b_combo;

            Timer enemySpawnTimer;
            Timer comboTimer;
            Timer showLevelTimer;


         /*

            //void spawnEnemy();












        private:




            //Context* context;
            */
    };
}

#endif /* _DodgeRace_H__ */